--SQL for XML parser

CREATE OR REPLACE FUNCTION xml_valid(text) RETURNS bool
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION xml_encode_special_chars(text) RETURNS text
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION xpath_string(text,text) RETURNS text
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION xpath_nodeset(text,text,text,text) RETURNS text
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION xpath_number(text,text) RETURNS float4
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION xpath_bool(text,text) RETURNS boolean
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;

-- List function

CREATE OR REPLACE FUNCTION xpath_list(text,text,text) RETURNS text
	AS '$libdir/pgxml'
	LANGUAGE 'c' STRICT IMMUTABLE;


CREATE OR REPLACE FUNCTION xpath_list(text,text) RETURNS text 
AS 'SELECT xpath_list($1,$2,'','')' language 'SQL' STRICT IMMUTABLE;



-- Wrapper functions for nodeset where no tags needed


CREATE OR REPLACE FUNCTION xpath_nodeset(text,text) RETURNS text AS
'SELECT xpath_nodeset($1,$2,'''','''')' language 'SQL' STRICT IMMUTABLE;


CREATE OR REPLACE FUNCTION xpath_nodeset(text,text,text) RETURNS text AS
'SELECT xpath_nodeset($1,$2,'''',$3)' language 'SQL' STRICT IMMUTABLE;

-- Table function

CREATE OR REPLACE FUNCTION xpath_table(text,text,text,text,text) RETURNS setof record
	AS '$libdir/pgxml'
	LANGUAGE 'c' STRICT STABLE;

-- XSLT functions
-- Delete from here to the end of the file if you are not compiling with
-- XSLT support.


CREATE OR REPLACE FUNCTION xslt_process(text,text,text) RETURNS text 
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT VOLATILE;

-- the function checks for the correct argument count

CREATE OR REPLACE FUNCTION xslt_process(text,text) RETURNS text 
	AS '$libdir/pgxml' LANGUAGE 'c' STRICT IMMUTABLE;
